// Copyright 2016 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --harmony-tailcalls --allow-natives-syntax

"use strict";

function deopt_function(func) {
  V8DeoptimizeFunction(func);
}

function f(x) {
  return deopt_function(h);
}

function g(x) {
  return f(x, 1);
}

function h(x) {
  g(x, 1);
}

V8SetForceInlineFlag(g);
V8SetForceInlineFlag(f);
V8NeverOptimizeFunction(deopt_function);

h(1);
h(1);
V8OptimizeFunctionOnNextCall(h);
h(1);
